#include "IZ_app.h"

void IZ_AppHandleSignal(i32 _signal) {
	interrupted = true;
}

// TODO move to each subsystem
// TODO unify loading of config from cmdline and config file
void IZ_AppLoadConfig(IZ_App *app, u8 argc, const char **argv) {
	memcpy_s(app, sizeof(IZ_App), &IZ_APP_DEFAULT_STATE, sizeof(IZ_App));

	const char *cmdline_buffer;
	if ((cmdline_buffer = lws_cmdline_option(argc, argv, "-d"))) {
		app->config.log_level = atoi(cmdline_buffer);
	}

	if ((cmdline_buffer = lws_cmdline_option(argc, argv, "-p"))) {
		app->config.port = atoi(cmdline_buffer);
	}
}

IZ_ProcedureResult IZ_AppInitialize(IZ_App *app, u8 argc, const char **argv) {
	interrupted = false;
	signal(SIGINT, IZ_AppHandleSignal);

	IZ_AppLoadConfig(app, argc, argv);
	IZ_LogInterceptWSMessages(app->config.log_level);
	if (IZ_WSServerCreateContext(&app->context, app->config.port)) {
		return 1;
	}

	return 0;
}

IZ_ProcedureResult IZ_AppRun(IZ_App *app, u8 argc, const char **argv) {
	if (IZ_AppInitialize(app, argc, argv)) {
		return 1;
	}

	i32 n = 0;
	while (n >= 0 && !interrupted) {
		n = lws_service(app->context, 0);
	}

	lws_context_destroy(app->context);
	return 0;
}
