#ifndef IZ_WSSERVER_H
#define IZ_WSSERVER_H

#include "libwebsockets.h"
#include <string.h>
#include "../IZ_common.h"
#include "IZ_network.h"

#define RING_COUNT 32

/* one of these created for each message */
typedef struct {
	void* payload; /* is malloc'd */
	size_t len;
	u8 binary: 1;
} IZ_WSServerMessage;

/* one of these is created for each client connecting to us */
typedef struct IZ_WSServerSessionData {
	struct IZ_WSServerSessionData* pss_list;
	struct lws* wsi;
	u32 tail;
	u8 culled: 1;
} IZ_WSServerSessionData;

/* one of these is created for each vhost our protocol is used with */
typedef struct {
	struct lws_context *context;
	struct lws_vhost *vhost;
	const struct lws_protocols *protocol;
	IZ_WSServerSessionData *pss_list; /* linked-list of live pss*/
	struct lws_ring *ring; /* ringbuffer holding unsent messages */
} IZ_WSServerVHostData;

i32 IZ_WSServerCallback(
	struct lws*,
	enum lws_callback_reasons,
	void*,
	void*,
	size_t
);

IZ_ProcedureResult IZ_WSServerCreateContext(struct lws_context**, u16);

#endif
